#!/usr/bin/perl

$config="/etc/bforce/sln_sf.conf";


##############################################################################
exit unless $ARGV[0];

use DB_File;
use Time::Local;


# parse config
open(CFG, "< $config") || die $!;
while($_=<CFG>){
$accdb=$1   if /^accessdb[\t\s]+(.+)$/i;
$dirdb=$1   if /^pathdb[\t\s]+(.+)$/i;
$filedb=$1  if /^filedb[\t\s]+(.+)$/i;
$aliasdb=$1 if /^aliasdb[\t\s]+(.+)$/i;
$limdb=$1   if /^limitdb[\t\s]+(.+)$/i;
$our=$1     if /^our[\t\s]+(.+)$/i;
$log=$1	    if /^log[\t\s]+(.+)$/i;
$note=$1    if /^note[\t\s]+(.+)$/i;
$cfg{$1}=$2 if /^addr[\t\s]+([\d:\/\.\*]+)[\t\s]+(.+)$/;
}
close CFG;

open(LOG, ">> $log") || die $!;
loging((scalar localtime)." starting pid:$$");

my @reztxt=("Result of file request","="x70);

# parse srif-file
open(SF, "< $ARGV[0]") || die $!;
my ($aka,$req,$res);
while($_=<SF>){
$aka=$1 if /^aka\s([\d:\/\.]+)/i;
$req=$1 if /requestlist\s+(.+)/i;
$res=$1 if /responselist\s+(.+)/i;
}
close SF;
die "error in srif file" unless $aka and $req and $res;


# get req files
open(RF, "< $req") || die $!;
my %rf;
while($_=<RF>){
$rf{lc($1)}='-' if /^([^\|\s]+)/;
}
close RF;
if(scalar keys %rf == 0){
push @reztxt, "Bad file request";
goto otchet;
}


my ($z,$n,$f,$p)=split /[\.\/\:]/,$aka;
#default
my $cfg=$cfg{"*"} if exists $cfg{"*"};
#zone
$cfg=$cfg{"$z:*/*.*"} if exists $cfg{"$z:*/*.*"};
#zone:net
$cfg=$cfg{"$z:$n/*.*"} if exists $cfg{"$z:$n/*.*"};
#zone:net/node
$cfg=$cfg{"$z:$n/$f.*"} if exists $cfg{"$z:$n/$f.*"};
#zone:net/node.point
$cfg=$cfg{"$z:$n/$f.$p"} if exists $cfg{"$z:$n/$f.$p"};
unless($cfg){
push @reztxt, "Your system is unknown";
goto otchet;
}

loging("System: $aka");
loging("ReqFiles: ".(join " ",keys %rf));

my ($file,$access);
if($cfg=~/^(\d+):(\d+)[\t\s]+(\d+):(\d+)[\t\s]+(\d+).(\d+).(\d+)$/){

if(time() < timelocal(0,0,0,$5,$6-1,$7)){
$file=$1;$access=$3;
}else{
$file=$2;$access=$4;
}
}elsif($cfg=~/^(\d+)[\t\s]+(\d+)$/){
$file=$1;$access=$2;
}else{
push @reztxt, "Config file have errors";
goto otchet;
}


# get info about spent file limits
dbmopen(my %lim, $limdb, 0600) || die $!;
$file=$lim{$aka} if exists $lim{$aka};

loging("Access: level: $access, file: $file");

dbmopen %acc,   $accdb,   0600;
dbmopen %dir,   $dirdb,   0600;
dbmopen %fls,   $filedb,  0600;
dbmopen %alias, $aliasdb, 0600;

my @tosend;
my $totsend=0;
my $totnum=0;

# workwith aliases
foreach $nfile (sort{$a cmp $b} keys %alias){

 if(exists $rf{lc($nfile)}){

    $rf{lc($nfile)}='+';
    # check file
    if(not $size=(stat($alias{lc($nfile)}))[7]){
    $msg=pf($nfile)."(alias) file is removed from disk";
    push @reztxt, $msg;
    loging($msg);
    next;
    }

    # check limits
    if($size > $file){
    $msg=pf($nfile)."(alias) no left limit ($size)";
    push @reztxt, $msg;
    loging($msg);
    next;
    }

    # hmm... ok, send
    $file-=$size;
    $totsend+=$size;
    $totnum++;
    push @tosend, $alias{$nfile};
    $msg=pf($nfile)."(alias) success ($size)";
    push @reztxt, $msg;
    loging($msg);
    next;

 }

}
dbmclose %alias;


# work with normal req files
# scan dirs
foreach $num (sort{$a<=>$b} keys %dir){

    foreach $nfile (split /\0/,$fls{$num}){

	if(exists $rf{lc($nfile)}){

	    $rf{lc($nfile)}='+';

	    # check access
	    if($acc{$num} > $access){
	    $msg=pf($nfile)."access denied";
	    push @reztxt, $msg;
	    loging($msg);
	    next;
	    }

	    # check file on disk
	    if(not $size=(stat("$dir{$num}/$nfile"))[7]){
	    $msg=pf($nfile)."file is removed from disk";
	    push @reztxt, $msg;
	    loging($msg);
	    next;
	    }

	    # check limits
	    if($size > $file){
	    $msg=pf($nfile)."no left limit ($size)";
	    push @reztxt, $msg;
	    next;
	    }

	    # hmm... ok, send
	    $file-=$size;
	    $totsend+=$size;
	    $totnum++;
	    push @tosend, "$dir{$num}/$nfile";
	    $msg=pf($nfile)."success ($size)";
	    push @reztxt, $msg;
	    loging($msg);

	}

    }

}


dbmclose %fls;
dbmclose %dir;
dbmclose %acc;


# make list of not found files
foreach (sort{$a cmp $b} keys %rf){
$msg=pf($_)."not found" if $rf{$_} eq '-';
push @reztxt, $msg;
loging($msg);
}

otchet:

# footer
push @reztxt,"="x70;
push @reztxt,"Sended $totnum of ".(scalar keys %rf)." files at $totsend bytes";
push @reztxt,"Today left limit $file bytes";

$pktname="/tmp/".sprintf("%lx",time-rand('999999')).".pkt";


# notaice
open(NOTE, "< $note") || die $!;
while($_=<NOTE>){
chomp;
push @reztxt, $_;
}
close NOTE;


# make pkt and write
open(PKT, "> $pktname") || die $!;
print PKT mkpkt(join '', map{"$_\r"} @reztxt);
close PKT;


# write response list
open(RES, "> $res") || die $!;
print RES map{"+$_\n"} @tosend;
print RES "-$pktname";
close RES;


#update limits
$lim{$aka}=$file;
dbmclose %lim;

loging("Exit.\n");
close LOG;

# exit
exit 0;


###############################################################################
sub pf{
uc($_[0])." ".("."x(25-length $_[0]))." "
}

sub loging{
print LOG $_[0]."\n";
}

sub mkpkt{
$body=$_[0];

$fromname='Freq Processor';
$destname='SysOp';
$subj='FREQ result';
$tag='(c) Sln ! freq processor v0.1';

@orig=split /[\:\/\.]/, $our;
@dest=split /[\:\/\.]/, $aka;
$orig[3]='0' unless $orig[3];
$dest[3]='0' unless $dest[3];

@time=localtime;
@month=("Jan","Feb","Mar","Apr","May","Jun",
        "Jul","Aug","Sep","Oct","Nov","Dec");

$header =pack("vvvvvvvvvvvvvA8vvvvvvvvvvVvvvvvvv",
	$orig[2],$dest[2],$time[5]+1900,$time[4],
	$time[3],$time[2],$time[1],$time[0],
	9600,    2,       $orig[1],$dest[1],
	1234,    '',	  $orig[0],$dest[0],
	0,       256,     1234,    1,
	$orig[0],$dest[0],$orig[3],$dest[3],
	0,       2,       $orig[2],$dest[2],
	$orig[1],$dest[1],1,       0);

$head =sprintf("%02d",$time[3])." $month[$time[4]] ".(substr $time[5],-2);
$head.="  ".sprintf("%02d:%02d:%02d",$time[2],$time[1],$time[0]);
$head.="\x00$destname\x00$fromname\x00$subj\x00";

$cluge ="\x01INTL $dest[0]:$dest[1]/$dest[2] $orig[0]:$orig[1]/$orig[2]\x0D";
$cluge.="\x01TOPT $dest[3]\x0D" if $dest[3] != 0;
$cluge.="\x01FMPT $orig[3]\x0D" if $orig[3] != 0;
$cluge.="\x01MSGID: $our ".sprintf("%lx",time)."\x0D\x0D\x0A";

$footer="\x0D--- $tag\x0D";

$header.$head.$cluge.$body.$footer;
}
